///<ObjektNummer>2284</ObjektNummer>

#if !defined(h_MmcCard)
#define h_MmcCard

// Defines
#define F_CPU 20000000
#define MCU ATMEGA644P

#include <avr\io.h>
#include "SpiMaster.h"
#include "MmcCardBuffer.h"

#include "M8_Mx8_SPI.h"

#define String StringBig
/////// DEBUG /////////////
//#define IsDEBUG	// auch im Paket "Debug" schalten
	#define DEBUG_BAUD 500000
	#define DEBUG_UART_NR 0
	#include "debugUart.h"

class MmcCard : public SpiMaster
{

public:

	//	configMmc()
	bool configMmc();

	//	writeSector()
	uint8_t writeSector(uint32_t addr);

	//	readSector()
	bool readSector(uint32_t addr);
	uint8_t lastError;
	//	true wenn configMmc erfolgreich war
	bool isInit;
	MmcCardBuffer buffer;
	//	Konstruktor
	MmcCard();

	//	Destruktor
	~MmcCard();

private:

protected:
	//	writeCommand()
	//	schreibt ein 6-Byte-Commando an die MMC-Card,
	//	setzt slaveSelect.on(); und lt es an.
	//	
	//	
	//	PA:
	//		SPI-Antwort nach dem Kommando, die nicht 0xff war,
	//		bei TimeOut = 0xff
	uint8_t writeCommand(uint8_t* cmd);

	//	readBlock()
	bool readBlock(uint8_t *cmd,uint8_t *buffer,uint16_t bytes);

};

#endif
