///<ObjektNummer>472</ObjektNummer>

#if !defined(h_SpiMaster)
#define h_SpiMaster

// Defines
#define F_CPU 20000000
#define MCU ATMEGA644P

#include <avr\io.h>
#include <avr\interrupt.h>
//#include <compat/deprecated.h>
#ifndef F_CPU
#define F_CPU 8000000
#endif
//#include "..\_allg\myAVR.h"
#include "Spi.h"

#include "M8_DigitalInOut.h"

#define String StringBig
/////// DEBUG /////////////
//#define IsDEBUG	// auch im Paket "Debug" schalten
	#define DEBUG_BAUD 500000
	#define DEBUG_UART_NR 0
	#include "debugUart.h"

class SpiMaster : public Spi
{
public:
enum{
prescale2=0b00000000,
prescale4=0b00000001,
prescale8=0b00000010,
prescale16=0b00000011,
prescale32=0b00000100,
prescale64=0b00000101,
prescale128=0b00000111
};
public:
	//	sendAndWait()
	//	sendet und empfngt ein Byte
	uint8_t sendAndWait(uint8_t dataIn);
	//	config()
	//	PE:
	//		presacler = eines von prescale2, prescale4, prescale8, prescale16, prescale32, prescale64, prescale128
	void config(uint8_t prescaler,volatile unsigned char& slavePortAdr, short slavePortBitmask=0);
	//	isTransmitComplete()
	//	
	//	PA:
	//		true wenn bertragung beendet
	bool isTransmitComplete();
	//	resetSlave()
	//	stellt einen High-Impuls auf SS sicher, um die Kommunikation zurckzusetzen
	void resetSlave()
{
	slaveSelect.off();	// SS=high
	waitMs(1);
	slaveSelect.on();	// SS=low
	
	/*
	if(!(PORTB & 0b00000100))
	{
		sbi(PORTB,2);	// SS=high
		waitMs(1);
	}
	cbi(PORTB,2);	// SS=low
	*/

} 
	//	spiRead()
	//	Sendet Daten aus einem Buffer.
	//	buffer = Zeiger auf Daten
	//	length = Anzahl der Bytes
	void spiRead(uint8_t * buffer, unsigned int length);
	//	spiWrite()
	//	Sendet Daten aus einem Buffer.
	//	buffer = Zeiger auf Daten
	//	length = Anzahl der Bytes
	void spiWrite(uint8_t * buffer, unsigned int length);
	//	configSpi()
	//	PE:
	//		presacler = eines von prescale2, prescale4, prescale8, prescale16, prescale32, prescale64, prescale128
	virtual void configSpi(uint8_t prescaler);
	DigitalOutLowActiv slaveSelect;
	//	Konstruktor
	SpiMaster();

	//	Destruktor
	~SpiMaster();

private:

protected:

	//	_sendAndWait()
	virtual uint8_t _sendAndWait(uint8_t data);

};

#endif
