///<ObjektNummer>1939</ObjektNummer>

#if !defined(h_Webserver)
#define h_Webserver

// Defines
#define F_CPU 20000000
#define MCU ATMEGA644P

#include <avr\io.h>
#include "EthernetTcp.h"

#include "Mx8_Timer.h"
#include "M8_Mx8_SPI.h"

#include <avr/pgmspace.h>
#include <string.h>
// wird fr eingehende Anfragen verwendet
#ifndef WEBSERVER_BUFFER_SIZE 
//#define 	WEBSERVER_BUFFER_SIZE 48
#define 	WEBSERVER_BUFFER_SIZE MAX_RECIVEBUFFER_LENGHT
//#define 	WEBSERVER_BUFFER_SIZE 148
#endif

#define String StringBig
/////// DEBUG /////////////
//#define IsDEBUG	// auch im Paket "Debug" schalten
	#define DEBUG_BAUD 500000
	#define DEBUG_UART_NR 0
	#include "debugUart.h"

class Webserver : public EthernetTcp
{

public:

	//	config_webserver()
	void config_webserver(uint16_t port);
	//	work()
	//	Muss kontinuierlich von auen aufgerufen werdenn, um eventuelle Anfragen zu bearbeiten.
	virtual void work();
	//	sendHttpHeader()
	//	PE:
	//		socket = Socket-Nummer
	//		type = HeaderTyp: h = html, g=gif, j=jpg
	bool sendHttpHeader(uint16_t socket, char type);
	//	Konstruktor
	Webserver();

	//	Destruktor
	~Webserver();

private:

protected:

	//	onWebRequest()
	virtual void onWebRequest(uint16_t socket, volatile unsigned char * pRequest, uint16_t reqLen);
	//	onWebRequestGet()
	//	PE:
	//		socket = akteuller Socket
	//		pFile = Zeiger auf URL, mit 0x00 abgeschlossen
	//		pPara = Zeiger auf URL-Parameter-Start, mit 0x00 getrennt
	//		pParaEnd = Zeiger auf Ende der Parameter, zeigt auf 0x00
	virtual void onWebRequestGet(uint16_t socket, unsigned char * pFile, unsigned char * pPara, unsigned char * pParaEnd);
	//	onIpPacketTcp()
	//	Wird ausgelst, wenn ein IP-Paket empfangen wurde.
	//	
	//	PE:
	//		lenght = Anzahl der Bytes
	//		ethernetBuffer = Zeiger auf Daten
	virtual void onIpPacketTcp(unsigned int lenght, unsigned char *ethernetBuffer);
	uint16_t port;
	//	0 = frei, Leerlauf
	//	10 = beim Empfang, vor ersten Daten
	//	20 = beim GET-Empfang
	//	30 = Empfang vollstndig
	//	40 = GET wird bearbeitet/beantwortet
	uint8_t volatile getState;
	uint8_t getPara [ WEBSERVER_BUFFER_SIZE+1 ];
	//	socket der bei GetEmpfang gerade benutzt wrid
	uint16_t getSocket;

};

#endif
